package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.utils.Constant;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @description 亲子关系问卷量表
 */
public class PCRScale extends BaseScale {
    public PCRScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public JSONObject scaleCalculate() throws Exception {
        //总分
        int score = 0;

        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject jsonObject1 = jsonArray.getJSONObject(i);
            if (jsonObject1.getString("checkItems").equals("很不符合")) {
                score += 1;
            } else if (jsonObject1.getString("checkItems").equals("不符合")) {
                score += 2;
            } else if (jsonObject1.getString("checkItems").equals("一般")) {
                score += 3;
            } else if (jsonObject1.getString("checkItems").equals("符合")) {
                score += 4;
            } else if (jsonObject1.getString("checkItems").equals("非常符合")) {
                score += 5;
            }
        }


        //得分列表
        Map<String, String> resultMap = new LinkedHashMap<>();
        resultMap.put("总分", String.valueOf(score));
        resultJson.put("总分", String.valueOf(score));


        if (score >= 20 && score <= 59) {
            resultMap.put("总分结论", "亲子关系已有了危机，须马上调整。 建议：您需要缓和与孩子之间的关系，可以尝试与孩子多聊聊学校里的生活，每天有哪些开心和不开心的事情，试着去倾听孩子的声音，像对待朋友般给出建议而不是严厉地去指责孩子。平常的时候可以尝试与孩子一同参与一些户外活动，增进彼此间的联系。");
            resultJson.put("总分结论", "亲子关系已有了危机，须马上调整。 建议：您需要缓和与孩子之间的关系，可以尝试与孩子多聊聊学校里的生活，每天有哪些开心和不开心的事情，试着去倾听孩子的声音，像对待朋友般给出建议而不是严厉地去指责孩子。平常的时候可以尝试与孩子一同参与一些户外活动，增进彼此间的联系。");
        } else if (score >= 60 && score <= 79) {
            resultMap.put("总分结论", "你们的相处还算良好。 建议：您和孩子相处的较好，继续保持这样的状况，尝试进一步地去与孩子沟通内心的想法和观念，您和孩子的关系可以更进一步。");
            resultJson.put("总分结论", "你们的相处还算良好。 建议：您和孩子相处的较好，继续保持这样的状况，尝试进一步地去与孩子沟通内心的想法和观念，您和孩子的关系可以更进一步。");
        } else if (score >= 80 && score <= 100) {
            resultMap.put("总分结论", "恭喜你，你们的亲子关系很好 建议：您和孩子相处的非常好，请继续保持下去。");
            resultJson.put("总分结论", "恭喜你，你们的亲子关系很好 建议：您和孩子相处的非常好，请继续保持下去。");
        }


        List<Map<String, String>> resultMapList = new ArrayList<>();
        resultMapList.add(resultMap);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList", resultMapList);
        returnJson.put("scaleName", Constant.SHEET_NAME_PCR);
        returnJson.put("resultJson", resultJson);

        return returnJson;
    }
}
